package edu.umd.dawn.common.annotations;

import lombok.extern.log4j.Log4j2;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

@Aspect
@Component
@Log4j2
public class DeprecatedAspect extends AspectBase<Deprecated> {

    @Around("@annotation(Deprecated) && within(edu.umd.dawn..**)")
    public Object run(ProceedingJoinPoint jointPoint) throws Exception, Throwable {
        Deprecated annotation = grabAnnotation(jointPoint, Deprecated.class);
        String descriptor = getFullDescriptor(jointPoint);

        if (!annotation.value().equals("")) {
            log.warn(String.format("method %s is deprecated - reason: %s", descriptor, annotation.value()));
        } else {
            log.warn(String.format("method %s is deprecated", descriptor));
        }
        Object proceed = jointPoint.proceed();
        return proceed;
    }
}
